#ifndef __LC212API_H
#define __LC212API_H


#define LC212_C_SC            1    // p⪮ 몠
#define LC212_C_OC            -1   // p
#define LC212_C_OK            0    // good
#define LC212_C_NOREF         2    //  p p殮
#define LC212_C_OLOAD         3    // pp㧪  室  p ᨣ쭮 p
#define LC212_C_UOLOAD        4    // p. pp㧪  p⪮ 몠
#define LC212_C_NOCH          100  //     , pp


#define LC212_FILTER_1STAGE   0
#define LC212_FILTER_2STAGE   1

#define  N_FIFO_212         4096
#define  LC212_MAXFLTN      5
#define  LC212_PARAMS_ADDR  0x3210



//void RESET_DIGITAL_FILTERS_LC212(WORD xSlot);
//void MANAGE_FILTERS_LC212(WORD xSlot, WORD xIirOn, WORD xFirOn);
//void GET_FILTERS_INFO_LC212(WORD xSlot, WORD *xIirOn, WORD *xFirOn, WORD *xDec, WORD *xloadIir, WORD *xloadFir, WORD *xtaps);
//void TEST_RESET(WORD xSlot); // !!!TMP
//***************************************************************************
//                       짮⥫
//
//void    RESET_POINTER_LC212(WORD xSlot);

//WORD     LOAD_FILTER_LC212(WORD xSlot, WORD FilterType, char *FilterFileName);
//void    STOP_LC212_FOR_CALIBR(WORD xSlot, WORD StopCalibrType);

//WORD     LOAD_LC212(WORD Slot, char *BiosFileName);
//void    STOP_LC212(WORD Slot);
//void    SET_MODE_LC212(WORD xSlot, WORD Mode, WORD HiRef, WORD FreqCode, WORD AC_Bit=1);

//void    CREATE_CHANNEL_LC212(WORD Slot, WORD Chan, WORD Diapazon);
//void    START_LC212(WORD Slot, WORD Mask, WORD IsUseFlash);
//void    SET_FIFO_SIZE_LC212(WORD xSlot, WORD xLen);
//WORD     GET_LC212_DATA(WORD xSlot, WORD NPoWORDs, WORD *xData);
//WORD     CALIBR_LC212(WORD xSlot, WORD Type, WORD IsUseFlash);
//void    RESTORE_LC212(WORD xSlot);
//void    RESET_LC212_AD7730(WORD xSlot);
//void    LC212_COLD_REBOOT(WORD xSlot);
//***************************************************************************


//***************************************************************************
//              pp 㦤 p ⫠
//
void    LC212_SelectAD7730(WORD xSlot, WORD xCodec);
void    LC212_SetRefVoltageAD7730(WORD xSlot, WORD xref);
WORD     LC212_CalcBufLen(double ff, WORD SF, WORD CHOP, WORD MaxPnt);
void    LC212_SetDataBufferLength(WORD xSlot, WORD xLen);
void    LC212_GetData(WORD xSlot, WORD *xData, WORD Type, WORD N);
void    LC212_SetFilter(WORD xSlot, unsigned long FilterWord);
void    LC212_SetModeReg(WORD xSlot, WORD ModeReg);
void    LC212_SetDacReg(WORD xSlot, WORD DacReg);
void    LC212_ForceSync(WORD xSlot);
void    LC212_StartAllAD7730(WORD xSlot, unsigned long Filter, WORD ModeReg, WORD Dac);
void    LC212_ManageFL1(WORD xSlot, WORD State);
//***************************************************************************

#define CHAN_212         8 // ᨬ쭮 ᫮ 
#define N_CODEC          4 // ᫮ p奬

// HH    LC-212
#define MODE_DYNAMIC     1 // 
#define MODE_STAT4       2 // ⨪  4- 
#define MODE_STAT8       3 // ⨪  8- 
#define MODE_IDLE        0 // 宫⮩ 室

//  p, ᮮ.  p᪠ 2 .
// p 樬樨  祭  㬥  2^n p,
// n=0...14
#define NFREQ_212        15
//extern  double    MAX_FILTER_FREQ_212;
//extern  WORD       Freq_212[NFREQ_212];
//extern  double    SampleFreq_212[NFREQ_212];
extern  char      *LC212_FilterNames[LC212_MAXFLTN+1];
#define UREF_212_5V      1 // p p殮 = 5 
#define UREF_212_2p5V    0 // p p殮 = 2.5 

#define NSCALE_212       8 // ᫮ 
// 
#define PM_10MV          0 // +/- 10 mV
#define PM_20MV          1 // +/- 20 mV
#define PM_40MV          2 // +/- 40 mV
#define PM_80MV          3 // +/- 80 mV

#define P_10MV           4 // +   10 mV
#define P_20MV           5 // +   20 mV
#define P_40MV           6 // +   40 mV
#define P_80MV           7 // +   80 mV

#define CM_PUT_8_BIT       10
#define CM_PUT_16_BIT      11
#define CM_WAIT_RDY_LOW    12
#define CM_GET_8_BIT       13
#define CM_GET_16_BIT      14
#define CM_PUT_24_BIT      15
#define CM_GET_24_BIT      16
#define CM_GET_24_BIT_CONT 17
#define CM_GET_16_BIT_CONT 18
#define CM_RESET_AD7730    19
#define CM_FILL_BUF        20
#define CM_SELECT_AD7730   21
#define CM_SET_REF_VOLT    22

#define CM_FILL_BUF_16     23
#define CM_SET_DAT_LEN     24

#define CM_FILL_BUF_24ALL  25

#define CM_FORCE_SYNC      26
#define CM_MANAGE_FL1      27

#define CM_SET_MAIN_MODE   32 // !!!TMP NEW !!!! 0...3
#define CM_SET_FREQ        33 // 1...16384 - 7.6 kHz....46 Hz
#define CM_WRITE_FLT       34
#define CM_RESET_DGT_FLT   35

/* ᠭ ॣ஢ (६) */
#define   LC212_BUFFER                  0x2000

#define   AD2186_STATUS                 0x3000
#define   AD2186_COMMAND                0x3001
#define   AD2186_RETURNVALUE            0x3002
#define   AD2186_COMMAND_PARAM1         0x3003

#define   LC212_MASKS_ADDR              0x3004
#define   LC212_MAIN_MODE               0x3005
#define   LC212_POINTER                 0x3006
#define   LC212_FLAG_END_BUFFER         0x300C

#define   LC212_LOGCHAN_ADDR            0x3010
#define   LC212_DACVALS_ADDR            0x3020

#define   ADR_MASK_RDY                  0x3202
#define   ADR_AD7730_DATA               0x3203
#define   ADR_AD7730_DATA_H             0x3204

#define   ADR_N_TAPS_212                0x304A
#define   ADR_N_TAPS4_212               0x304D

#define   ADR_DECCNTR                   0x3049
#define   ADR_ISIIRON                   0x304B
#define   ADR_ISFIRON                   0x304C
#define   ADR_IIR_LOAD                  0x304E
#define   ADR_FIR_LOAD                  0x304F

#define   ADR_IM_HERE                   0x3050


//
//    for LABs needs
//
#define LC212_16BIT         0
#define LC212_16UPPER_BIT24 1
#define LC212_24BITALL      2


//  p  ⥬
#define LC212_CALIBR_MODES     4
extern WORD     CalModes_212[LC212_CALIBR_MODES];
#define CLB_212_INT_ZERO       0x1     // p 
#define CLB_212_INT_SCALE      0x2     // p 誠
#define CLB_212_EXT_ZERO       0x4     // 譨 
#define CLB_212_EXT_SCALE      0x8     //  誠

#define LC212_FLASH_USE     1
#define LC212_FLASH_IGNORE  0

#define LC212_ENADIS_WRITE_ADDR   0x3309

#endif

