#ifndef __LC352API_H
#define __LC352API_H

#define MODES_LC352 4             // 1:1, 1:8, 1:64, 1:512 ⥭p
#define MEMSIZE_LC352 32768.0

#define SIGNAL_SINUS  0
#define SIGNAL_MEANDR 1
#define SIGNAL_PILA   2
#define SIGNAL_TREUG  3
#define SIGNAL_CONST  4


#define LC352_CONNECT_MU 2
#define LC352_NORMAL     0
#define LC352_CURRENT    3

extern double Kusil_LC352[MODES_LC352];
extern double FREQ_LC352;        // p  p 
extern double TMIN_LC352;

#endif